use super::command_base::{BasicWritableCommand, SerializableCommand};

#[derive(new)]
pub struct ProgramInput {
    mix_effect: u8,
    source: u16,
}

impl SerializableCommand for ProgramInput {
    fn payload(&self, _version: crate::enums::ProtocolVersion) -> Vec<u8> {
        let mut buf = vec![0; 4];
        buf[..1].copy_from_slice(&self.mix_effect.to_be_bytes());
        buf[2..].copy_from_slice(&self.source.to_be_bytes());

        buf
    }
}

impl BasicWritableCommand for ProgramInput {
    fn get_raw_name(&self) -> &'static str {
        "CPgI"
    }

    fn get_minimum_version(&self) -> crate::enums::ProtocolVersion {
        crate::enums::ProtocolVersion::Unknown
    }
}
