use crate::enums;

#[derive(Getters, new)]
pub struct SuperSourceBox {
    pub enabled: bool,
    pub source: f64,
    pub x: f64,
    pub y: f64,
    pub size: f64,
    pub cropped: bool,
    pub crop_top: f64,
    pub crop_bottom: f64,
    pub crop_left: f64,
    pub crop_right: f64,
}

#[derive(Getters, new)]
pub struct SuperSourceProperties {
    pub art_fill_source: f64,
    pub art_cut_source: f64,
    pub art_option: enums::SuperSourceArtOption,
    pub art_pre_multiplied: bool,
    pub art_clip: f64,
    pub art_gain: f64,
    pub art_invert_key: bool,
}

#[derive(Getters, new)]
pub struct SuperSourceBorder {
    pub border_enabled: bool,
    pub border_bevel: enums::BorderBevel,
    pub border_outer_width: f64,
    pub border_inner_width: f64,
    pub border_outer_softness: f64,
    pub border_inner_softness: f64,
    pub border_bevel_softness: f64,
    pub border_bevel_position: f64,
    pub border_hue: f64,
    pub border_saturation: f64,
    pub border_luma: f64,
    pub border_light_source_direction: f64,
    pub border_light_source_altitude: f64,
}

#[derive(Getters, new)]
pub struct SuperSource {
    index: f64,
    boxes: [Option<SuperSourceBox>; 4],
    pub properties: Option<SuperSourceProperties>,
    pub border: Option<SuperSourceBorder>,
}
